(function (global, factory) {
    typeof exports === 'object' && typeof module !== 'undefined' ? factory(exports, require('@angular/core'), require('@angular/common'), require('jquery'), require('eonasdan-bootstrap-datetimepicker')) :
    typeof define === 'function' && define.amd ? define('ng-ts-datepicker', ['exports', '@angular/core', '@angular/common', 'jquery', 'eonasdan-bootstrap-datetimepicker'], factory) :
    (global = global || self, factory(global['ng-ts-datepicker'] = {}, global.ng.core, global.ng.common, global.jqueryImport));
}(this, function (exports, core, common, jqueryImport) { 'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation. All rights reserved.
    Licensed under the Apache License, Version 2.0 (the "License"); you may not use
    this file except in compliance with the License. You may obtain a copy of the
    License at http://www.apache.org/licenses/LICENSE-2.0

    THIS CODE IS PROVIDED ON AN *AS IS* BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
    KIND, EITHER EXPRESS OR IMPLIED, INCLUDING WITHOUT LIMITATION ANY IMPLIED
    WARRANTIES OR CONDITIONS OF TITLE, FITNESS FOR A PARTICULAR PURPOSE,
    MERCHANTABLITY OR NON-INFRINGEMENT.

    See the Apache Version 2.0 License for specific language governing permissions
    and limitations under the License.
    ***************************************************************************** */

    function __decorate(decorators, target, key, desc) {
        var c = arguments.length, r = c < 3 ? target : desc === null ? desc = Object.getOwnPropertyDescriptor(target, key) : desc, d;
        if (typeof Reflect === "object" && typeof Reflect.decorate === "function") r = Reflect.decorate(decorators, target, key, desc);
        else for (var i = decorators.length - 1; i >= 0; i--) if (d = decorators[i]) r = (c < 3 ? d(r) : c > 3 ? d(target, key, r) : d(target, key)) || r;
        return c > 3 && r && Object.defineProperty(target, key, r), r;
    }

    function __metadata(metadataKey, metadataValue) {
        if (typeof Reflect === "object" && typeof Reflect.metadata === "function") return Reflect.metadata(metadataKey, metadataValue);
    }

    var DATETIME_FORMAT = 'DD/MM/YYYY HH:mm:ss';
    var DATE_FORMAT = 'DD/MM/YYYY';
    var TIME_FORMAT = 'DD/MM/YYYY';

    var jquery = jqueryImport;
    var NgTsDatepickerDirective = /** @class */ (function () {
        function NgTsDatepickerDirective(el) {
            this.el = el;
            /**
             * Emits date selected from datepicker
             */
            this.dateChange = new core.EventEmitter();
            /**
             * Emits empty value once datepicker is clicked
             */
            this.click = new core.EventEmitter();
            this.defaultOptions = {
                allowInputToggle: true,
                format: DATETIME_FORMAT,
                preventInputKeys: true
            };
            this.hasParent = false;
            this.internalOptions = {};
        }
        NgTsDatepickerDirective.prototype.ngOnInit = function () {
            var _this = this;
            this.internalOptions = Object.assign(this.internalOptions, this.defaultOptions, this.options);
            var $parent = jquery(this.el.nativeElement.parentNode);
            this.dpElement = $parent.hasClass('input-group') ? $parent : jquery(this.el.nativeElement);
            if ($parent.hasClass('input-group')) {
                this.dpElement = $parent;
                this.hasParent = true;
            }
            else {
                this.dpElement = jquery(this.el.nativeElement);
            }
            this.appendCalendarIcon();
            var datepickerOptions = Object.assign({}, this.internalOptions);
            delete datepickerOptions.preventInputKeys;
            this.dpElement.datetimepicker(datepickerOptions);
            this.dpElement.data('DateTimePicker').date(this.date);
            this.dpElement.on('dp.change', function (e) {
                if (e.date !== _this.date) {
                    _this.date = e.date;
                    _this.dateChange.emit(e.date);
                }
            });
            if (this.internalOptions.preventInputKeys) {
                this.dpElement.on('keydown', function (e) {
                    e.preventDefault();
                });
            }
            this.dpElement.on('click', function (e) {
                _this.click.emit();
            });
        };
        NgTsDatepickerDirective.prototype.ngOnChanges = function (changes) {
            if (this.dpElement) {
                var dpe_1 = this.dpElement.data('DateTimePicker');
                if (!!dpe_1) {
                    if (changes.options) {
                        jquery.map(changes.options.currentValue, function (value, key) {
                            dpe_1[key](value);
                        });
                    }
                    if (changes.date && changes.date.currentValue !== undefined) {
                        dpe_1.date(changes.date.currentValue);
                    }
                    else {
                        dpe_1.date(null);
                    }
                }
            }
        };
        NgTsDatepickerDirective.prototype.appendCalendarIcon = function () {
            var groupAddon = document.createElement('span');
            var calendarIcon = document.createElement('span');
            groupAddon.setAttribute('class', 'input-group-addon calendar-addon');
            calendarIcon.setAttribute('class', 'glyphicon glyphicon-calendar');
            groupAddon.appendChild(calendarIcon);
            if (this.hasParent) {
                this.dpElement.append(groupAddon);
                this.dpElement.addClass('datepicker');
            }
            else {
                this.dpElement.parent().addClass('datepicker');
                this.dpElement.after(groupAddon);
            }
        };
        __decorate([
            core.Input(),
            __metadata("design:type", Object)
        ], NgTsDatepickerDirective.prototype, "date", void 0);
        __decorate([
            core.Input(),
            __metadata("design:type", Object)
        ], NgTsDatepickerDirective.prototype, "options", void 0);
        __decorate([
            core.Output(),
            __metadata("design:type", core.EventEmitter)
        ], NgTsDatepickerDirective.prototype, "dateChange", void 0);
        __decorate([
            core.Output(),
            __metadata("design:type", core.EventEmitter)
        ], NgTsDatepickerDirective.prototype, "click", void 0);
        NgTsDatepickerDirective = __decorate([
            core.Directive({
                // tslint:disable-next-line:directive-selector
                selector: '[ngTsDatepicker]'
            }),
            __metadata("design:paramtypes", [core.ElementRef])
        ], NgTsDatepickerDirective);
        return NgTsDatepickerDirective;
    }());

    var NgTsDatepickerModule = /** @class */ (function () {
        function NgTsDatepickerModule() {
        }
        NgTsDatepickerModule = __decorate([
            core.NgModule({
                imports: [
                    common.CommonModule
                ],
                exports: [
                    NgTsDatepickerDirective
                ],
                declarations: [
                    NgTsDatepickerDirective
                ]
            })
        ], NgTsDatepickerModule);
        return NgTsDatepickerModule;
    }());

    exports.DATETIME_FORMAT = DATETIME_FORMAT;
    exports.DATE_FORMAT = DATE_FORMAT;
    exports.NgTsDatepickerDirective = NgTsDatepickerDirective;
    exports.NgTsDatepickerModule = NgTsDatepickerModule;
    exports.TIME_FORMAT = TIME_FORMAT;

    Object.defineProperty(exports, '__esModule', { value: true });

}));
//# sourceMappingURL=ng-ts-datepicker.umd.js.map
